# Detect the distribution in use
%global __despace /usr/bin/head -n 1 | /usr/bin/tr -d '[:space:]' | %{__sed} -e 's/[(].*[)]//g'
%global __lower4 /usr/bin/cut -c 1-4 | /usr/bin/tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(%{__sed} -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(%{__sed} -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS & White Box as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "wbel"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

%{!?perl_vendorlib: %global perl_vendorlib %(eval "`%{__perl} -V:installvendorlib`"; echo $installvendorlib)}
%{!?__id_u: %global __id_u %([ -x /bin/id ]&&echo /bin/id||([ -x /usr/bin/id ]&&echo /usr/bin/id||echo /bin/true)) -u}

Summary:	Extensible (class) oriented internet server
Name:		perl-Net-Server
Version:	0.99
Release:	1.%{__distinit}%{__distvers}
License:	GPL+ or Artistic
Group:		Development/Libraries
Url:		http://search.cpan.org/dist/Net-Server/
Source0:	http://search.cpan.org/CPAN/authors/id/R/RH/RHANDOM/Net-Server-%{version}.tar.gz
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildArch:	noarch
Requires:	perl(:MODULE_COMPAT_%(eval "`%{__perl} -V:version`"; echo $version))
BuildRequires:	perl(ExtUtils::MakeMaker), perl(Test::More), perl(Time::HiRes)

# IO::Multiplex support is optional, but not including it causes build problems in some packages...
Requires:	perl(IO::Multiplex) >= 1.05
# Also buildreq IO::Multiplex for use in test suite
BuildRequires:	perl(IO::Multiplex) >= 1.05
 
%description
"Net::Server" is an extensible, generic Perl server engine.
"Net::Server" combines the good properties from "Net::Daemon" (0.34),
"NetServer::Generic" (1.03), and "Net::FTPServer" (1.0), and also from
various concepts in the Apache Webserver.

"Net::Server" attempts to be a generic server as in "Net::Daemon" and
"NetServer::Generic". It includes with it the ability to run as an inetd
process ("Net::Server::INET"), a single connection server ("Net::Server"
or "Net::Server::Single"), a forking server ("Net::Server::Fork"), a
preforking server which maintains a constant number of preforked
children ("Net::Server::PreForkSimple"), or as a managed preforking
server which maintains the number of children based on server load
("Net::Server::PreFork"). In all but the inetd type, the server provides
the ability to connect to one or to multiple server ports.

"Net::Server" uses ideologies of "Net::FTPServer" in order to provide
extensibility. The additional server types are made possible via
"personalities" or sub classes of the "Net::Server". By moving the
multiple types of servers out of the main "Net::Server" class, the
"Net::Server" concept is easily extended to other types (in the near
future, we would like to add a "Thread" personality).

"Net::Server" borrows several concepts from the Apache Webserver.
"Net::Server" uses "hooks" to allow custom servers such as SMTP, HTTP,
POP3, etc. to be layered over the base "Net::Server" class. In addition
the "Net::Server::PreFork" class borrows concepts of min_start_servers,
max_servers, and min_waiting servers. "Net::Server::PreFork" also uses
the concept of an flock serialized accept when accepting on multiple
ports (PreFork can choose between flock, IPC::Semaphore, and pipe to
control serialization).

%prep
%setup -q -n Net-Server-%{version} 
 
%build
%{__perl} Makefile.PL INSTALLDIRS=vendor
%{__make} %{?_smp_mflags}

%check
%{__make} test

%clean
%{__rm} -rf %{buildroot}

%install
%{__rm} -rf %{buildroot}
%{__make} pure_install PERL_INSTALL_ROOT=%{buildroot}
/usr/bin/find %{buildroot} -type f -name .packlist -exec %{__rm} -f {} ';'
/usr/bin/find %{buildroot} -depth -type d -exec /bin/rmdir {} ';' 2>/dev/null
%{_fixperms} %{buildroot}

%files
%defattr(-,root,root,-)
%doc README* Changes examples
%{perl_vendorlib}/Net/
%{_mandir}/man3/Net::Server.3pm*
%{_mandir}/man3/Net::Server::Daemonize.3pm*
%{_mandir}/man3/Net::Server::Fork.3pm*
%{_mandir}/man3/Net::Server::HTTP.3pm*
%{_mandir}/man3/Net::Server::INET.3pm*
%{_mandir}/man3/Net::Server::MultiType.3pm*
%{_mandir}/man3/Net::Server::Multiplex.3pm*
%{_mandir}/man3/Net::Server::PreFork.3pm*
%{_mandir}/man3/Net::Server::PreForkSimple.3pm*
%{_mandir}/man3/Net::Server::Proto.3pm*
%{_mandir}/man3/Net::Server::Proto::SSL.3pm*
%{_mandir}/man3/Net::Server::Proto::SSLEAY.3pm*
%{_mandir}/man3/Net::Server::Proto::TCP.3pm*
%{_mandir}/man3/Net::Server::Proto::UDP.3pm*
%{_mandir}/man3/Net::Server::Proto::UNIX.3pm*
%{_mandir}/man3/Net::Server::SIG.3pm*
%{_mandir}/man3/Net::Server::Single.3pm*


%changelog
* Mon Jul 19 2010 Paul Howarth <paul@city-fan.org> 0.99-1
- Update to 0.99
  - Add SSLeay proto - finally a workable SSL solution
  - Add minimal Net::Server::TiedHandle for STD{IN,OUT} to work with SSLEAY
  - Net::Server::TiedHandle support tied_stdin_callback & tied_stdout_callback
  - Allow for port => 0 which lets the OS auto assign a port on some OSes
  - Add idle_loop_hook to PreForkSimple and PreFork
  - Add consistent formatting capabilities to the log method
  - Warn when default listen value is used - try to make it a sensible default
  - Allow for non-zero exit value - particularly when called from fatal
  - Add customizable check_for_spawn and min_child_ttl settings in PreFork
  - Add other_child_died_hook
  - Make Multiplex do $mux->add($sock) for UDP sockets
  - Change Net::Server::Daemonize to use kill 0 rather than the unportable `ps`
  - Fix calling conventions of MultiType
  - Avoid select in SSLEAY that was allowing for infinite spin loop
  - Fix tie_stdout mode to not warn about unopen handles
  - Added Net::Server::HTTP base class for basic HTTP daemon handling
  - Change examples/httpd to use Net::Server::HTTP
- BR: perl(Time::HiRes)

* Fri Jun 25 2010 Paul Howarth <paul@city-fan.org> 0.97-6
- Rebuild for perl 5.12.1 in Rawhide

* Thu Jun  3 2010 Paul Howarth <paul@city-fan.org> 0.97-5
- Fix dist tag for RHEL-6 Beta

* Mon Mar  1 2010 Paul Howarth <paul@city-fan.org> 0.97-4
- Dist tag for Rawhide no longer needs special-casing
- Use %%{_fixperms} macro instead of our own %%{__chmod} incantation

* Tue Sep 22 2009 Paul Howarth <paul@city-fan.org> 0.97-3
- Define RPM macros in global scope

* Fri Nov 14 2008 Paul Howarth <paul@city-fan.org> 0.97-2
- Tweak dist tag macros to work on current Rawhide with three-part releasenum
- Clarify license as GPL version 1 or later, or Artistic (i.e. same as perl)

* Thu Jul 26 2007 Paul Howarth <paul@city-fan.org> 0.97-1
- Update to 0.97
- BuildRequire perl(ExtUtils::MakeMaker) & perl(Test::More)

* Tue Mar 27 2007 Paul Howarth <paul@city-fan.org> 0.96-1
- Update to 0.96

* Mon Feb  5 2007 Paul Howarth <paul@city-fan.org> 0.95-1
- Update to 0.95
- Fix dist tag for fc7 onwards
- Fix argument order for find with -depth
- Buildreq perl(IO::Multiplex) for use in test suite

* Wed Jul 12 2006 Paul Howarth <paul@city-fan.org> 0.94-1
- Update to 0.94
- Define %%{__id_u} in a more portable way

* Mon Mar 27 2006 Paul Howarth <paul@city-fan.org> 0.93-1
- Update to 0.93

* Thu Mar 23 2006 Paul Howarth <paul@city-fan.org> 0.92-1
- Update to 0.92

* Thu Mar  9 2006 Paul Howarth <paul@city-fan.org> 0.91-1
- Update to 0.91
- Use search.cpan.org URLs

* Mon Jan  9 2006 Paul Howarth <paul@city-fan.org> 0.90-2
- Add IO::Multiplex dep as per Fedora Extras

* Tue Dec  6 2005 Paul Howarth <paul@city-fan.org> 0.90-1
- Update to 0.90

* Thu Nov 24 2005 Paul Howarth <paul@city-fan.org> 0.89-1
- Update to 0.89
- Remove redundant compiler optimization settings, not needed for noarch pkg
- Don't use macros in paths for build-time commands, hardcode them instead
- Simplify distribution-detection
- Remove buildroot unconditionally in %%clean and %%install
- Fix directory ownership

* Wed Jun 22 2005 Paul Howarth <paul@city-fan.org> 0.88-1
- Update to 0.88

* Mon May 23 2005 Paul Howarth <paul@city-fan.org> 0.87-3
- Rewrite spec file in (mainly) Fedora Extras style
- Include full URL for source
- Fix URL
- Use MODULE_COMPAT dependency style and remove explicit perl dependency

* Thu Apr 15 2004 Paul Howarth <paul@city-fan.org> 0.87-2
- Added explicit perl dependency to ensure that an RPM built on a
  system with an updated version of perl (and hence having files
  installed in a place that a non-updated system won't find them)
  will not install on the non-updated system. In such cases, just
  rebuild from the source RPM.
- Changed distribution-identifying macros for greater portability.

* Thu Mar 04 2004 Paul Howarth <paul@city-fan.org> 0.87-1
- Update to 0.87
- Added GPL as license option

* Mon Feb 16 2004 Paul Howarth <paul@city-fan.org> 0.86-2
- Unified spec file for Red Hat and Fedora Core

* Tue Feb 03 2004 Paul Howarth <paul@city-fan.org> 0.86-1.fc1
- Initial RPM build
